#include <IRremote.h>

unsigned long valores_control[8];
#define frente valores_control[0]
#define tras valores_control[1]
#define direita valores_control[2]
#define esquerda valores_control[3]

#define fre_dir valores_control[4]
#define fre_esq valores_control[5]
#define tra_dir valores_control[6]
#define tra_esq valores_control[7]

#define desliga 551489775
#define controle_altera 551522415
const unsigned long val_const = 4294967295;

//variaveis auxiliares
int cont_altera = 0;
int cont = 0;
unsigned long aux_altera = 0;
unsigned long aux = 0;
unsigned long direcao = 0;

// valores referente aos pinos do Arduino
int RECV_PIN = 12;
const int pinBotaoAltera = 10;
const int pinFrente = 8;
const int pinTras = 7;
const int pinDir = 6;
const int pinEsq = 5;




IRrecv irrecv(RECV_PIN);

decode_results results;

void setup()
{
  Serial.begin(9600);
  irrecv.enableIRIn();// Inicia para receber
  pinMode(pinFrente, OUTPUT);
  pinMode(pinTras, OUTPUT);
  pinMode(pinEsq, OUTPUT);
  pinMode(pinDir, OUTPUT);
  pinMode(pinBotaoAltera, INPUT);
}

void loop() {
  //para verificar se o botão foi clicado
  if(digitalRead(pinBotaoAltera)){
    aux_altera = controle_altera;
    for(int i = 0; i <= 7; i++){
      valores_control[i] = desliga;
    }
    Entrou();
    cont_altera = 0;
  }

  //para verificar se o controle foi acionado
  if (irrecv.decode(&results)) {
    aux = results.value; 

    if(results.value == controle_altera){
      aux_altera = controle_altera;
      for(int i = 0; i <= 7; i++){
        valores_control[i] = desliga;
      }
      Entrou();
      cont_altera = 0;
    }
    if(aux_altera == controle_altera){
      if(results.value != controle_altera && results.value != val_const){
        valores_control[cont_altera] = results.value;
        cont_altera++;
      }
      if(cont_altera == 8){
        cont_altera = 0;
        aux_altera = desliga;
      }
    }

    if(aux != val_const){
      if(aux == frente){
        direcao = frente;
      }
      else if(aux == tras){
        direcao = tras;
      }
      else if(aux == esquerda){
        direcao = esquerda;
      }
      else if(aux == direita){
        direcao = direita;
      }
      else if(aux == fre_dir){
        direcao = fre_dir;
      }
      else if(aux == fre_esq){
        direcao = fre_esq;
      }
      else if(aux == tra_dir){
        direcao = tra_dir;
      }
      else if(aux == tra_esq){
        direcao = tra_esq;
      }
      else if(aux == desliga){
        direcao = desliga;
      }
    }
    if(direcao == frente && aux == val_const || direcao == frente){
      digitalWrite(pinFrente, HIGH);
    }
    else if(direcao == tras && aux == val_const || direcao == tras){
      digitalWrite(pinTras, HIGH);
    }
    else if(direcao == esquerda && aux == val_const || direcao == esquerda){
      digitalWrite(pinEsq, HIGH);
    }
    else if(direcao == direita && aux == val_const || direcao == direita){
      digitalWrite(pinDir, HIGH);
    }
    else if(direcao == fre_dir && aux == val_const || direcao == fre_dir){
      digitalWrite(pinDir, HIGH);
      digitalWrite(pinFrente, HIGH);   
    }
    else if(direcao == fre_esq && aux == val_const || direcao == fre_esq){
      digitalWrite(pinEsq, HIGH);
      digitalWrite(pinFrente, HIGH);   
    }
    else if(direcao == tra_dir && aux == val_const || direcao == tra_dir){
      digitalWrite(pinDir, HIGH);
      digitalWrite(pinTras, HIGH);      
    }
    else if(direcao == tra_esq && aux == val_const || direcao == tra_esq){
      digitalWrite(pinEsq, HIGH);
      digitalWrite(pinTras, HIGH);      
    }

    irrecv.resume(); // receber novo valor do sensor
    cont = 0;
  }
  else{
    Serial.println(cont);
    if(cont > 35){
      digitalWrite(pinFrente, LOW);
      digitalWrite(pinTras, LOW);
      digitalWrite(pinDir, LOW);
      digitalWrite(pinEsq, LOW);
      direcao = desliga;
      cont = 0;
    }
    cont++;
  }
}


void Entrou(){
  digitalWrite(pinFrente, HIGH);
  digitalWrite(pinTras, HIGH);
  digitalWrite(pinDir, HIGH);
  digitalWrite(pinEsq, HIGH);
  delay(300);
  digitalWrite(pinFrente, LOW);
  digitalWrite(pinTras, LOW);
  digitalWrite(pinDir, LOW);
  digitalWrite(pinEsq, LOW);
}




















